package sos.settings.converter;

import sos.util.*;

/**
 * <p>Title: sos.settings.converter.SOSSettingsConverter.java </p>
 * <p>Description: Konvertieren der Konfigurationsdateien. <br>
 * Die Konvertierung erfolgt entweder von xml zu ini Datei oder umgekehrt.</p>
 * <p>Copyright: Copyright (c) 08.07.2004</p>
 * <p>Company: SOS GmbH</p>
 * @author Mrvet ksz
 * @resource sos.util.jar
 */
public class SOSSettingsConverter {
     
    /**
     * Attribut: SOSStandardLogger Objekt.
     * @see sos.util.SOSStandardLogger 
     * */
    private SOSStandardLogger sosLogger = null;
    
    /** Attribut: Name der Konfigurationsdatei*/
    private String configFile = "";
        
        
    /**
     * Konstruktor.
     * 
     * @throws Exception
     */
    public SOSSettingsConverter() throws Exception {
        
    }        
    
    /**
     * Konstruktor.
     * 
     * @param SOSStandardLogger
     *  @see sos.util.SOSStandardLogger
     * @throws Exception
     */
    public SOSSettingsConverter(SOSStandardLogger sosLogger_) throws Exception {
        sosLogger = sosLogger_;
        
    }
    
    /**
     * Konstruktor.
     * 
     * @param SOSStandardLogger
     * @see sos.util.SOSStandardLogger
     * @throws Exception
     */
    public SOSSettingsConverter(String configFile_, SOSStandardLogger sosLogger_) throws Exception {
        sosLogger = sosLogger_;
        configFile = configFile_;
        
    }
    
    /**
     * Ldt die Konfigurationsdatei. <br>
     * Diese Methode liefert true, wenn die Konfigurationsdatei erfolgreich 
     * geladen wurde. 
     * 
     * @return boolean
     * @throws Exception
     */
    public boolean loadSettings() throws Exception {
        boolean retVal  =true;
        try {
            return retVal;
        } catch (Exception e) {
            throw new Exception("\n ->..error in " + SOSClassUtil.getMethodName() + " " + e);
        }
    }
    
    /**
     * Schreibt die Konfigurationsdatei in eine neue Konfigutaionsdatei. 
     * z.B. von ini zu xml oder umgekehrt.
     * @return boolean
     * @throws Exception
     */
    public boolean writeSettingFile() throws Exception {
        boolean retVal  =true;
        try {
            return retVal;
        } catch (Exception e) {
            throw new Exception("\n ->..error in " + SOSClassUtil.getMethodName() + " " + e);
        }
    }
       
    /**
     * Hier wird ein Wert zu den Property <i>sosLogger</i> gesetzt.
     * Der Typ der Property <i>sosLogger</i> ist <i>SOSStandardLogger</i>.
     *
     * @see sos.util.SOSStandardLogger
     * @param sosLogger
     */
    public void setSosLogger(SOSStandardLogger sosLogger) {
        this.sosLogger = sosLogger;
    }
    
}
