// $Id: series_factory_script.h 3546 2005-04-03 08:30:29Z jz $

#ifndef __SERIES_FACTORY_SCRIPT_H
#define __SERIES_FACTORY_SCRIPT_H

#include "../kram/sosscrpt.h"

namespace sos {
namespace factory {

//----------------------------------------------------------------------------------Script_instance

struct Script_instance
{
                                Script_instance             ()                              : _loaded(false) {}

    void                        init                        ( const string& language );
    void                        set_language                ( const string& language );
    void                        load                        ( const string& script_text );
    IDispatch*                  dispatch                    () const                        { return _script_site? _script_site->dispatch() : NULL; }
  //void                        add_obj                     ( const ptr<IDispatch>&, const string& name );
    void                        close                       ();
    Variant                     call_if_exists              ( const char* name );
    Variant                     call_if_exists              ( const char* name, const Variant& param );
    Variant                     call_if_exists              ( const char* name, Variant* param );
    Variant                     call                        ( const char* name );
    Variant                     call                        ( const char* name, const Variant    & param );
    Variant                     call                        ( const char* name, Variant* param );
  //Variant                     property_get                ( const char* name );
    void                        property_put                ( const char* name, const Variant& v ) { _script_site->property_put( name, v ); } 
    void                        property_putref             ( const char* name, const Variant& v ) { _script_site->property_putref( name, v ); } 
    void                        optional_property_put       ( const char* name, const Variant& v );
    bool                        name_exists                 ( const char* name )            { return _loaded && _script_site->name_exists(name); }
    bool                        loaded                      ()                              { return _loaded; }
  //void                        interrupt                   ();

                                operator bool               () const                        { return _script_site != NULL; }

    ptr<Script_site>           _script_site;
    bool                       _loaded;
};

//-------------------------------------------------------------------------------------------------

} //namespace factory
} //namespace sos

#endif
