// $Id: z_posix_process.h 3773 2005-07-01 08:26:11Z jz $

#ifndef __ZSCHIMMER_WINDOWS_PROCESS_H
#define __ZSCHIMMER_WINDOWS_PROCESS_H


#include "z_posix.h"
#include <signal.h>             // SIGKILL


namespace zschimmer {
namespace posix {

//-------------------------------------------------------------------------------------------------
    
std::vector<string>             argv_from_command_line      ( const string& command_line );

//------------------------------------------------------------------------------------------Process

struct Process : Process_base
{
                                Process                     ();
                                Process                     ( int pid )                             : _zero_(this+1) { attach_pid( pid ); }
    virtual                    ~Process                     ();

    STDMETHODIMP            put_Priority_class              ( VARIANT* priority )                   { return E_NOTIMPL; } 
    STDMETHODIMP            get_Priority_class              ( BSTR* result )                        { return E_NOTIMPL; }

    void                        close                       ();                                
    void                        start                       ( const string& command );
    void                        start                       ( const std::vector<string>& command );
    void                        attach_pid                  ( int pid )                             { close();  _pid = pid; }
    bool                    set_priority                    ( int );
    int                         priority                    ();
  //bool                        raise_priority              ( int difference );
    void                        wait                        ();
    bool                        wait                        ( double seconds );
    bool                        terminated                  ();
    int                         exit_code                   ();
    int                         termination_signal          ();
    void                        kill                        ( int signal = SIGKILL );
    bool                        try_kill                    ( int signal = SIGKILL );
    bool                        opened                      () const                                { return _working_pid != 0; }
  //string                      obj_name                    ();


  private:
    bool                        call_waitpid                ( bool wait );


    Fill_zero                  _zero_;
    int                        _working_pid;
    int                        _exit_code;
    int                        _termination_signal;
    
    bool                       _priority_set;
    int                        _priority;
  //bool                       _raise_priority_set;
  //int                        _raise_priority;
};

//-------------------------------------------------------------------------------------------------

} //namespace posix
} //namespace zschimmer

#endif
